=== ubuntu/xr-usb-serial/Makefile ===
obj-m := xr_usb_serial_common.o

obj-$(CONFIG_USB_SERIAL_EXAR)			+= xr_usb_serial_common.o
